use wasm_bindgen::prelude::*;
use caith::{RollResultType, Roller, RollError};

#[wasm_bindgen]
pub fn roll(s: String) -> String {
  match rust_roll(&s) {
    Ok(roll) => match roll {
      RollResultType::Single(single) => {
        single.to_string(false)
      },
      _ => "Unsupported format".to_string(),
    },
    Err(err) => err.to_string(),
  }
}

fn rust_roll(s: &str) -> Result<RollResultType, RollError> {
    Ok(Roller::new(&s)?.roll()?.get_result().clone())
}

#[cfg(test)]
pub mod tests {
  use super::roll;

  #[test]
  fn test_roll_d20() {
    let answer = roll("1d20");
    println!("Answer: {}", answer);
  }
}
